<template>
    <v-app>
        <v-container>
            <h1>The awesome METRO ToDo app</h1>
            <h2>Using the "Vuetify" framework</h2>

            <!-- The form -->
            <v-form :model="form" ref="form" v-model="valid" lazy-validation>
                <v-layout align-center>
                    <v-flex md6 d-flex>
                        <v-text-field v-model="form.todo" required label="Activity"
                        :rules="todoRules">
                        </v-text-field>

                    </v-flex>
                    <v-flex md3 d-flex>
                        <v-select
                                :items="priorities"
                                label="Priority"
                                v-model="form.priority"
                        ></v-select>
                    </v-flex>

                    <v-flex md3 d-flex>
                        <v-menu
                                ref="menu1"
                                v-model="menu1"
                                lazy
                        >
                            <v-text-field
                                    slot="activator"
                                    v-model="form.deadline"
                                    label="Deadline"
                                    prepend-icon="event"
                                    readonly
                            ></v-text-field>
                            <v-date-picker v-model="form.deadline" no-title scrollable>
                                <v-spacer></v-spacer>
                                <v-btn flat color="primary" @click="menu = false">Cancel</v-btn>
                                <v-btn flat color="primary" @click="$refs.menu.save(date)">OK</v-btn>
                            </v-date-picker>
                        </v-menu>
                    </v-flex>
                    <v-flex md3 d-flex>
                        <v-btn color="success" @click="onSubmit">Submit</v-btn>
                    </v-flex>
                </v-layout>
            </v-form>

            <!-- the table -->
            <v-data-table
                    :headers="headers"
                    :items="items"
                    hide-actions
                    class="elevation-1"
            >
                <template slot="items" slot-scope="props">
                    <td>{{ props.item.description }}</td>
                    <td>{{ format(props.item.deadline) }}</td>
                    <td>{{ props.item.priority }}</td>
                    <td class="justify-center layout px-0">
                        <v-icon
                                small
                                @click="onDelete(props.item)"
                        >
                            delete
                        </v-icon>
                    </td>
                </template>
            </v-data-table>

            <!-- the snackbar -->
            <v-snackbar v-model="snackbar" :top="true">
                {{snackbarText}}
            </v-snackbar>

            <!-- the dialog -->
            <v-dialog ref="confirm" v-model="dialog" persistent max-width="290">
                <v-card>
                    <v-card-title class="headline">{{message}}</v-card-title>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="green darken-1" flat @click.native="no">No</v-btn>
                        <v-btn color="green darken-1" flat @click.native="yes">Yes</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>

        </v-container>
    </v-app>
</template>

<script>

    import moment from 'moment'

    export default {
        name: 'app',

        data() {
            return {
                form: {
                    todo: ''
                },

                menu1: false,

                // Values for the dropdown
                priorities: [
                    'low',
                    'medium',
                    'high',
                    'blocker'
                ],

                headers: [
                    {text: 'Activity', value: 'description'},
                    {text: 'Deadline', value: 'deadline'},
                    {text: 'priority', value: 'priority'},
                    {text: 'Actions', value: 'name', sortable: false}
                ],

                // Initial items
                items: [
                    {
                        description: "Buy some potatoes",
                        deadline: new Date(2018, 9, 1),
                        priority: 'high'
                    },
                    {
                        description: "Cook Dranikis",
                        deadline: new Date(2018, 9, 2),
                        priority: 'medium'
                    },
                    {
                        description: "Clean up the kitchen",
                        deadline: new Date(2018, 9, 3),
                        priority: 'low'
                    }
                ],

                snackbar: false,
                snackbarText: '',

                // Message for the dialog
                dialog: false,
                message: '',

                // validation
                valid: true,
                todoRules: [
                    v => !!v || 'Name is required',
                ]
            }
        },
        mounted() {
            moment.locale('de');
        },

        methods: {
            format(date) {
                return moment(date).format('L')
            },
            onSubmit() {
                if (this.$refs.form.validate()) {
                    this.items.push({
                        description: this.form.todo,
                        deadline: this.form.deadline,
                        priority: this.form.priority,
                        added: new Date()
                    })
                    this.snackbarText = 'The item has been added'
                    this.snackbar = true
                    this.form.todo = ''
                    this.form.deadline = ''
                    this.form.priority = ''
                }

            },
            async onDelete() {
                if (await this.open('Are you sure?', {color: 'red'})) {
                    this.items.splice(1, 1);
                }
            },

            // format the date
            formatter(row) {
                return moment(row.deadline).format('L');
            },

            // Functions for the dialog
            open(message) {
                this.dialog = true
                this.message = message
                return new Promise((resolve, reject) => {
                    this.resolve = resolve
                    this.reject = reject
                })
            },
            no() {
                this.resolve(false)
                this.dialog = false
            },
            yes() {
                this.resolve(true)
                this.dialog = false
            }


        }
    }
</script>
